use ffr* policyShock* date_q using ${dirTemp}/tsdata_macro, clear

label var ffr3shockTightWeighted "Three-month Fed funds future surprises" 
label var ffr3shockTightGBWeiUncorr "... purged of Greenbook forecasts"
label var ffr3shockTightSignWeighted "... sign-restricted stock market comovement"
label var ffr3shockTightAllWeighted "... unscheduled meetings and conference calls included"
label var ffr3shockTightNoQEWeighted "... QE announcements excluded"
label var policyShockTightWeighted "'Policy indicator' surprise"

foreach var of varlist ffr3shockTightWeighted policyShockTightWeighted ffr3shockTightGBWeiUncorr ffr3shockTightSignWeighted ffr3shockTightAllWeighted ffr3shockTightNoQEWeighted {
	replace `var' = `var' * 100 // in basis points
}
 
estpost sum ffr3shockTightWeighted ffr3shockTightAllWeighted ffr3shockTightGBWeiUncorr ffr3shockTightSignWeighted  ffr3shockTightNoQEWeighted policyShockTightWeighted
est store A 

esttab A using ${dirOutput}/TableA2.tex, nonum cell((mean(fmt(2)) sd(fmt(2)) min(fmt(2)) max(fmt(2)) count(fmt(0)))) unstack label noobs replace nomtitles
